-- LOAD ALL SHARED ITEMS FOR DUCKHUNT AND HOGANS ALLEY
-- DRAW THEM TO OFFSCREEN WHEN CALLED

--VAR
missile_fall_speed = 1

-- Defining Colors

yellow = Color.new(255, 255, 0)
red = Color.new(255, 0, 0)
green = Color.new(0, 255, 0)
blue = Color.new(0, 0, 255)
lightblue = Color.new(60, 140, 255)
darkblue = Color.new(0, 0, 180)
black = Color.new(0, 0, 0)
white = Color.new(255, 255, 255)
pink = Color.new(255, 160, 180)
lightgray = Color.new(206, 206, 206)
gray = Color.new(150, 150, 150)
darkgray = Color.new(50,50,50)
turquoise = Color.new(130,220,205)

day9 = Color.new(140, 200, 255)
day1 = Color.new(0, 40, 75)

colorset = {turquoise,yellow,red,green,blue,lightblue,darkblue,black,white,pink,lightgray,gray,darkgray}

colornum = 1
scolornum = 8
colornum_max = 14

mc = turquoise
sc = black

hsb_x = 30
hsb_y = 240

-- Draw Window
function draw_window(x,y,size_x,size_y,color,cutoff,c_y,c_y_2,c_y_3,c_y_4,c_y_5)
	screen:fillRect(x - 1, y - 1, size_x, size_y, white)
	screen:fillRect(x + 1, y + 1, size_x, size_y, black)
	screen:fillRect(x, y, size_x, size_y, color)
	if cutoff ~= nil and cutoff ~= 0 then
		c_y = c_y + y
		c_long = x + size_x - 5
		if cutoff == 2 then
			c_y_2 = c_y_2 + y
			draw_cutoffs(x,y,cutoff,c_y,c_long,c_y_2)
		end
		if cutoff <= 1 then
			draw_cutoffs(x,y,cutoff,c_y,c_long)
		end
		if cutoff == 3 then
			c_y_2 = c_y_2 + y
			c_y_3 = c_y_3 + y
			draw_cutoffs(x,y,cutoff,c_y,c_long,c_y_2,c_y_3)
		end
		if cutoff == 4 then
			c_y_2 = c_y_2 + y
			c_y_3 = c_y_3 + y
			c_y_4 = c_y_4 + y
			draw_cutoffs(x,y,cutoff,c_y,c_long,c_y_2,c_y_3,c_y_4)
		end
		if cutoff == 5 then
			c_y_2 = c_y_2 + y
			c_y_3 = c_y_3 + y
			c_y_4 = c_y_4 + y
			c_y_5 = c_y_5 + y
			draw_cutoffs(x,y,cutoff,c_y,c_long,c_y_2,c_y_3,c_y_4,c_y_5)
		end
	end
end

function draw_cutoffs(x,y,num,c_y,c_long,c_y_2,c_y_3,c_y_4,c_y_5)
	if num >= 1 then
		screen:drawLine(x + 2, c_y - 1, c_long, c_y - 1, white)
		screen:drawLine(x + 2, c_y, c_long, c_y, gray)
		if num >= 2 then
			screen:drawLine(x + 2, c_y_2 - 1, c_long, c_y_2 - 1, white)
			screen:drawLine(x + 2, c_y_2, c_long, c_y_2, gray)
		end
		if num >= 3 then
			screen:drawLine(x + 2, c_y_3 - 1, c_long, c_y_3 - 1, white)
			screen:drawLine(x + 2, c_y_3, c_long, c_y_3, gray)
		end
		if num >= 4 then
			screen:drawLine(x + 2, c_y_4 - 1, c_long, c_y_4 - 1, white)
			screen:drawLine(x + 2, c_y_4, c_long, c_y_4, gray)
		end
		if num >= 5 then
			screen:drawLine(x + 2, c_y_5 - 1, c_long, c_y_5 - 1, white)
			screen:drawLine(x + 2, c_y_5, c_long, c_y_5, gray)
		end
	end
end

function ingamepause()
		stopped=0
		gostart=false
--		screen:clear()
--		screen2:clear()
		screen:print(220, 128, "PAUSE", white)
		screen:print(205, 138, "Press Start", white)
		screen.waitVblankStart()
		screen.flip()
		screen.waitVblankStart(10)
		repeat
			pad = Controls.read()
			if pad:start() then 
				gostart=true
			end
		until gostart==true
		screen.waitVblankStart(10)
	
end

-- AUDIO
snd_shotgun_fire = Sound.load("Data/Audio/shotgun2.wav",false)
snd_squish = Sound.load("Data/Audio/squish.wav",false)

sky02 = Image.load("DATA/BACKGROUNDS/sky02.png")
-- DUCK HUNT ITEMS
Duckhunt_sheet_a = Image.load("DATA/SHEETS/Duckhunt_sheet_A.png")

img_shots_ammo = {{x = 6.75, y = 8.4},{x = 6.75, y = 8.4},{x = 6.75, y = 8.4},{x = 6.75, y = 8.4}}
img_shotbar = {{x = 3, y = 5.8 },{x = .8, y = 2 },}
img_target = {x = 13.5 , y = 6}
img_redclay = {x = 41.4 , y = 14.5}
img_redduck = {x = 41.4,y = 15.5}
img_scorebar = {x = 4.6 , y = 7.2}
img_bullet = {x = 48, y = 10}

--img_clays = {{x = 19.2 , y = 21},{x = 20.2 , y = 21},{x = 21.2 , y = 21},{x = 21.2 , y = 21},{x = 34 , y = 23},{x = 34 , y = 23},{x = 36 , y = 23},{x = 36 , y = 23},{x = 38 , y = 23},{x = 20.3 , y = 14.7},{x = 9.9 , y = 8.4},{x = 6.2 , y = 6.4},{x = 6.2 , y = 6.4}}
img_clays = {{x = 8 , y = 21.7},{x = 8.8 , y = 21.7},{x = 7.9 , y = 21.7},{x = 9.2 , y = 21.7},{x = 8.2 , y = 21.7},{x = 10.4 , y = 21.7},{x = 9.5 , y = 21.7},{x = 14.8 , y = 21.7},{x = 13.7 , y = 21.7},{x = 7.1 , y = 21.7},{x = 3 , y = 10.5},{x = 1.6 , y = 6.8},{x = 0.1 , y = 5.5}}

img_duck_a = {{x = 0, y = 0},{x = 1.13, y = 0},{x = 2.3, y = 0},{x = 3.4, y = 0},{x = 4.53, y = 0},{x = 5.6, y = 0},{x = 6.75, y = 0},{x = 7.9, y = 0},{x = 9, y = 0},{x = 10.1, y = 0.1},{x = 11.3, y = 0.1},{x = 12.42, y = 0.1},{x = 3.4, y = 1.2},{x = 4.03, y = 1.2},{x = 5.6, y = 1.2}}
img_duck_a_shot = {{x = 1, y = 1.3},{x = 2, y = 1.3}}
img_duck_a_fall = {{x = 22, y = 0},{x = 0, y = 1}}

-- DUCK B
img_duck_b = {{x = 0.05, y = 3.8},{x = 1.12, y = 3.8},{x = 2.25, y = 3.8},
{x = 3.45, y = 3.8},{x = 4.6, y = 3.8},{x = 5.65, y = 3.8},
{x = 6.76, y = 3.85},{x = 7.88, y = 3.85},{x = 8.88, y = 3.85},
{x = 9.9, y = 3.9},{x = 11.1, y = 3.9},{x = 12.18, y = 3.9},{x = 3.4, y = 4.9},{x = 4.03, y = 4.9},{x = 5.6, y = 4.9}}
img_duck_b_shot = {{x = 1, y = 5.2},{x = 2, y = 5.2}}
img_duck_b_fall = {{x = 22, y = 3.2},{x = 0, y = 4.2}}

--DUCK C
img_duck_c = {{x = 6.73, y = 1.35},{x = 7.85, y = 1.35},{x = 9, y = 1.35},{x = 10.15, y = 1.35},{x = 11.32, y = 1.35},{x = 12.42, y = 1.35},{x = 6.73, y = 2.55},{x = 7.85, y = 2.55},{x = 8.95, y = 2.55},{x = 10.08, y = 2.55},{x = 11.25, y = 2.55},{x = 12.35, y = 2.55},{x = 3.38, y = 2.5},{x = 4.03, y = 2.5},{x = 5.6, y = 2.5}}
img_duck_c_shot = {{x = 2, y = 2.55},{x = 1, y = 2.55}}
img_duck_c_fall = {{x = 22, y = 1},{x = 0, y = 2}}

img_doglaugh = {{x = 5.4, y = 4.5},{x = 6.35, y = 4.5}}
img_duckshotbar = {x = 1.9, y = 5.7}
img_dog_wduck = {x = 0, y = 5}
img_flyaway = {x = 1.1, y = 8.4}
img_dog_no_duck = {x = 1.55, y = 5.7}
img_round = {x = 3.1, y = 5.3}
img_gameover = {x = 0, y = 5.2}
img_miss = {x = 5.2, y = 7.1}
img_graybar = {x = 0, y = 0}
img_round_miss = {x = 1.62, y = 1.7}
img_numbers = {{x = 6.8, y = 11.8},{x = 8.2, y = 11.8},{x = 9.9, y = 11.8},{x = 11.4, y = 11.8},{x = 12.8, y = 11.8},{x = 6.8, y = 13.2},{x = 8.2, y = 13.2},{x = 9.7, y = 13.2},{x = 11.4, y = 13.2},{x = 10, y = 13.2}}

img_keg = {{x = 0, y = 7.2},{x = 1, y = 7.2},{x = 2.2, y = 7.2},{x = 3.4, y = 7.2},{x = 4.4, y = 7.2}}

-- HOGAN'S ALLEY ITEMS
Hogans_alley_sheet_a = Image.load("DATA/SHEETS/Hogans_alley_sheet_a.png")

img_score_box = { x = 3.2, y = 4 }
img_top_score_box = { x = 3.2, y = 4 }

img_target_cop = { x = 0, y = 0 }
img_target_lady = { x = 1, y = 0 }
img_target_man = { x = 2, y = 0 }
img_target_gang_a = { x = 3, y = 0 }
img_target_gang_b = { x = 4.2, y = 0 }
img_target_gang_c = { x = 5.1, y = 0 }

img_target_shot = { x = 0, y = 1 }
img_target_spin1 = { x = 2, y = 1 }
img_target_spin2 = { x = 1, y = 1 }
img_target_spin3 = { x = 3, y = 1 }

img_brick = {x = 4.8, y = 9}
img_brick_bar = {x = 0, y = 14}

-- HOGAN'S ALLEY ITEMS
Hogans_alley_sheet_BG = Image.load("DATA/SHEETS/Hogans_alley_sheet_BG.png")
Hogans_alley_sheet_BG_2 = Image.load("DATA/SHEETS/Hogans_alley_sheet_BG_2.png")

img_hogans_bg_1 = { x = 0, y = 0 }
img_hogans_bg_2 = { x = 0, y = 1 }
img_hogans_bg_3 = { x = 0, y = 0 }
img_hogans_bg_4 = { x = 0, y = 1 }

bg_temp = img_hogans_bg_1

-- Wild Gunman Sheet
Wild_Gunman_Sheet_a = Image.load("DATA/SHEETS/Wild_Gunman_Sheet_a.png")
Wild_Gunman_Sheet = Image.load("DATA/SHEETS/Wild_Gunman_Sheet.png")
wild_gunman_modea_bg = Image.load("DATA/BACKGROUNDS/wild_gunman_modea_bg.PNG")

img_gunman_a = {{ x = 0, y = 0},{ x = 1.05, y = 0 },{ x = 2.1, y = 0 },{ x = 3.2, y = 0 },{ x = 4.2, y = 0 },{ x = 5.3, y = 0 },{ x = 2.1, y = 1 },{ x = 1.05, y = 1 },{ x = 0, y = 1 },{ x = 3.1, y = 1 },{ x = 4.2, y = 1 }} 
img_hat = {x =8.2 ,y = 6.2}

img_youwon = {x = 0, y = 1}
img_youlost = {x = .9, y = 1}
img_fire = {x = 0, y = 0}
img_foul = {x = 1, y = 0}

-- TARGET START LOCATION
-- VAR
x0= 100
y0= 100
sb_x= 370
sb_y= 230
dog_no_duck_x = 15
dog_no_duck_y = 35
img_round_x = 210
img_round_y = 100
numbers_x = 240
numbers_y = 140
sheet_a_x = 65
sheet_a_y = 40
sheet_b_x = 65
sheet_b_y = 40
sheet_box_x = 100
sheet_box_y = 40
sheet_is = "ammo_location"
sheet_b_is = "targets"

img_guts = {}
img_guts[1] = Image.load("DATA/IMAGES/guts01.png")
img_guts[2] = Image.load("DATA/IMAGES/guts02.png")
img_guts[3] = Image.load("DATA/IMAGES/guts03.png")

-- SHEET CODE
-- MODE TOOLS

function draw_flyway(x,y)
	screen:blit(x, y, Duckhunt_sheet_a, 80*img_flyaway.x, 25*img_flyaway.y, 80, 25, true)
end

function draw_doglaugh(num,x,y)
	screen:blit(x, y, Duckhunt_sheet_a, 45*img_doglaugh[num].x, 55*img_doglaugh[num].y, 45, 55, true)
end

function draw_ha_bg(num, x, y)
	if num == 1 then
		bg_temp = img_hogans_bg_1
	elseif num == 2 then
		bg_temp = img_hogans_bg_2
	elseif num == 3 then
		bg_temp = img_hogans_bg_3
	elseif num == 4 then
		bg_temp = img_hogans_bg_4
	end
	if num == 1 or num == 2 then
		screen:blit(x, y, Hogans_alley_sheet_BG, 480*bg_temp.x, 215*bg_temp.y, 480, 215, true)
	elseif num == 3 or num == 4 then
		screen:blit(x, y, Hogans_alley_sheet_BG_2, 480*bg_temp.x, 215*bg_temp.y, 480, 215, true)
	end
end

function draw_redduck(x,y)
	sheet_is = "redclay"
	drawTileToOffscreen_sheet_a(img_redduck, x, y)
end

function draw_target()
	sheet_is = "target"
	drawTileToOffscreen_sheet_a(img_target, x0, y0)
end

function draw_duckshotbar(x,y)
	sheet_is = "duckshotbar"
	drawTileToOffscreen_sheet_a(img_duckshotbar, x, y)
end
function draw_scorebox()
	sheet_is = "scorebar"
	drawTileToOffscreen_sheet_a(img_scorebar, sb_x,sb_y)
end
function draw_score_box(x,y)
	sheet_is = "scorebar"
	drawTileToOffscreen_sheet_a(img_scorebar, x,y)
end
function draw_duck(num, x, y, duck)
	if num == 14 then
		z = 40
	else
		z = 36
	end
	if num == 13 or num == 14 or num == 15 then
		w = 35
	else
		w = 33
	end
	if duck == 1 then
		duck = img_duck_a
	elseif duck == 2 then
		duck = img_duck_b
	elseif duck == 3 then
		duck = img_duck_c
	end
	screen:blit(x, y, Duckhunt_sheet_a, z*duck[num].x, w*duck[num].y, z, w, true)
end
function draw_duck_shot(num, x, y, duck)
	if duck == 1 then
		duck = img_duck_a_shot
	elseif duck == 2 then
		duck = img_duck_b_shot
	elseif duck == 3 then
		duck = img_duck_c_shot
	end
	screen:blit(x, y, Duckhunt_sheet_a, 36*duck[num].x, 33*duck[num].y, 36, 33, true)
end
function draw_bullet(x,y)
	screen:blit(x, y, Duckhunt_sheet_a, 10*img_bullet.x, 10*img_bullet.y, 10, 10, true)
end
function draw_duck_fall(num, x, y, duck)
	if duck == 1 then
		duck = img_duck_a_fall
	elseif duck == 2 then
		duck = img_duck_b_fall
	elseif duck == 3 then
		duck = img_duck_c_fall
	end
	screen:blit(x, y, Duckhunt_sheet_a, 22*duck[num].x, 40*duck[num].y, 22, 40, true)
end
function draw_dog_wduck(x, y)
	screen:blit(x, y, Duckhunt_sheet_a, 50*img_dog_wduck.x, 50*img_dog_wduck.y, 50, 50, true)
end
function draw_foul(x, y)
	screen:blit(x, y, Wild_Gunman_Sheet, 125*img_foul.x, 65*img_foul.y, 125, 65, true)
end
function draw_fire(x, y)
	screen:blit(x, y, Wild_Gunman_Sheet, 125*img_fire.x, 65*img_fire.y, 125, 65, true)
end
function draw_youlost(x, y)
	screen:blit(x, y, Wild_Gunman_Sheet, 195*img_youlost.x, 75*img_youlost.y, 195, 75, true)
end
function draw_youwon(x, y)
	screen:blit(x, y, Wild_Gunman_Sheet, 180*img_youwon.x, 75*img_youwon.y, 180, 75, true)
end
function draw_hat(x, y)
	screen:blit(x, y, Wild_Gunman_Sheet_a, 50*img_hat.x, 30*img_hat.y, 50, 30, true)
end
function draw_gunman_a(num, x, y)
	screen:blit(x, y, Wild_Gunman_Sheet_a, 75*img_gunman_a[num].x, 135*img_gunman_a[num].y, 75, 135, true)
end
function draw_keg(num, x, y)
	screen:blit(x, y, Hogans_alley_sheet_a, 35*img_keg[num].x, 25*img_keg[num].y, 35, 25, true)
end
function draw_brick_bar(x, y)
	screen:blit(x, y, Hogans_alley_sheet_a, 480*img_brick_bar.x, 15*img_brick_bar.y, 480, 15, true)
end
function draw_brick(x, y)
	screen:blit(x, y, Hogans_alley_sheet_a, 40*img_brick.x, 20*img_brick.y, 40, 20, true)
end
function graybar(y)
	screen:blit(0, y, Duckhunt_sheet_a, 480*img_graybar.x, 37*img_graybar.y, 480, 37, true)
end
function round_miss(x, y)
	screen:blit(x, y, Hogans_alley_sheet_a, 180*img_round_miss.x, 55*img_round_miss.y, 180, 55, true)
end
function draw_number(round_num)
	sheet_is = "number1"
	if round_num == 10 then
		sheet_is = "number10"
	end
	screen:print(img_round_x + 27,img_round_y + 20, round_num,white)
--	drawTileToOffscreen_sheet_a(img_numbers[round_num],numbers_x,numbers_y)
end

function draw_dog_no_duck()
	sheet_is = "dog_no_duck"
	drawTileToOffscreen_sheet_a(img_dog_no_duck, dog_no_duck_x, dog_no_duck_y)
end

function draw_img_round()
	sheet_is = "round_box"
	drawTileToOffscreen_sheet_a(img_round, img_round_x, img_round_y)
end

function draw_img_gameover()
	sheet_is = "gameover"
	drawTileToOffscreen_sheet_a(img_gameover, img_round_x, img_round_y)
end

function drawTileToOffscreen_sheet_a(tile, x, y)
	sheet_a_x = 65
	sheet_a_y = 40
	if sheet_is == "scorebar" then
		sheet_a_x = 60
		sheet_a_y = 30
	elseif sheet_is == "round_box" then
		sheet_a_x = 55
		sheet_a_y = 40
	elseif sheet_is == "gameover" then
		sheet_a_x = 90
		sheet_a_y = 40
	elseif sheet_is == "number1" then
		sheet_a_x = 20
		sheet_a_y = 20
	elseif sheet_is == "number10" then
		sheet_a_x = 25
		sheet_a_y = 20
	elseif sheet_is == "shotbar_location" then
		sheet_a_x = 125
		sheet_a_y = 30
	elseif sheet_is == "ammo_location" then
		sheet_a_x = 35
		sheet_a_y = 26
	elseif sheet_is == "target" then
		sheet_a_x = 35
		sheet_a_y = 35
	elseif sheet_is == "redclay" then
		sheet_a_x = 12
		sheet_a_y = 12
	elseif sheet_is == "miss" then
		sheet_a_x = 45
		sheet_a_y = 25
	elseif sheet_is == "dog_no_duck" then
		sheet_a_x = 35
		sheet_a_y = 45
	elseif sheet_is == "duckshotbar" then
		sheet_a_x = 125
		sheet_a_y = 30
	elseif sheet_is == "clay" then
		if tile == img_clays[1] then
			sheet_a_x = 55
			sheet_a_y = 15
		elseif tile == img_clays[2] or tile == img_clays[3] then
			x = x + 2
			sheet_a_x = 45
			sheet_a_y = 15
		elseif tile == img_clays[4] or tile == img_clays[5] then
			x = x + 6
			sheet_a_x = 35
			sheet_a_y = 15
		elseif tile == img_clays[6] or tile == img_clays[7] then
			x = x + 10
			sheet_a_x = 25
			sheet_a_y = 15
		elseif tile == img_clays[8] or tile == img_clays[9] then
			x = x + 14
			sheet_a_x = 15
			sheet_a_y = 15
		elseif tile == img_clays[10] then
			x = x + 4
			y = y + 2
			sheet_a_x = 25
			sheet_a_y = 15
		elseif tile == img_clays[11] then
			x = x + 2
			sheet_a_x = 45
			sheet_a_y =	30
		elseif tile == img_clays[12] then
			x = x - 3
			y = y - 8
			sheet_a_x = 50
			sheet_a_y =	45
		elseif tile == img_clays[13] then
			x = x - 14
			y = y - 14
			sheet_a_x = 65
			sheet_a_y =	55
		end
	end
	screen:blit(x, y, Duckhunt_sheet_a, sheet_a_x*tile.x, sheet_a_y*tile.y, sheet_a_x, sheet_a_y, true)
end

function draw_miss(x,y)
	sheet2_a_x = 45
	sheet2_a_y = 25
	screen:blit(x, y, Hogans_alley_sheet_a, sheet2_a_x*img_miss.x, sheet2_a_y*img_miss.y, sheet2_a_x, sheet2_a_y, true)
end

function draw_ha_target(tile, x, y)
	screen:blit(x, y, Hogans_alley_sheet_a, 75*tile.x, 85*tile.y, 75, 85, true)
end
function draw_ha_score_box(tile, x, y)
	screen:blit(x, y, Hogans_alley_sheet_a, sheet_box_x*tile.x, sheet_box_y*tile.y, sheet_box_x, sheet_box_y, true)
end
