-- Save Game Name
game = "wild_gunman"
sb_x= 0
end_game = 0

foul = 0
reward = 2300
reward_base = 2300
can_shoot = 20
level = 1
levelopen = 100
score = 0
shotdelay = 0
canshoot_on = 0
reset_all = 0
your_time = 0
text_timer = 0
kill_count = 0
dead_count = 3

--VAR gunmen
hat_y = 80
gunman_action = "walk"
gunman_a_x = 500
gunman_a_y = 80
gunman_a_num = 1
gunman_shot_timer = 10
gunman_walk_timer = 20
gunman_draw_timer = 30
gunman_draw_timer_max = 30
walkspeed_gunman_a = .5
leavespeed_gunman_a = .8
gunman_shoot_timer = 60

function didshothit()
	if shotdelay == 0 then
		pad = Controls.read()
		if pad:cross() or pad:r() then
			if canshoot_on == 1 then	
				snd_shotgun_fire:play()
				shotdelay = 20
				if gunman_draw_timer >= 1 then
					if ((x0 + 15) > gunman_a_x + 10) and ((x0 + 15) < (gunman_a_x + 70)) and ((y0 + 16) > gunman_a_y) and ((y0 + 16) < (gunman_a_y + 80)) then
						gunman_action = "shot"
						gunman_a_num = 10
						score = score + reward
						kill_count = kill_count + 1
						canshoot_on = 0
					end
				end
			else
				if gunman_action ~= "leave" and gunman_action ~= "fire" then
					snd_shotgun_fire:play()
					shotdelay = 20
					if gunman_draw_timer >= 1 then
						if ((x0 + 15) > gunman_a_x + 10) and ((x0 + 15) < (gunman_a_x + 70)) and ((y0 + 16) > gunman_a_y) and ((y0 + 16) < (gunman_a_y + 80)) then
							gunman_action = "leave"
							gunman_a_num = 7
							foul = 1
							dead_count = dead_count - 1
							canshoot_on = 0
						end
					end
				end
			end
		end
	end
end

function wild_modea()
	if shotdelay >= 1 then
		shotdelay = shotdelay - 1
	end
	targetControl()
	if gunman_action == "walk" then
		gunman_a_walk()
	end
	if gunman_action == "draw" then
		gunman_a_draw()
	end
	if gunman_action == "leave" then
		gunman_a_leave()
	end
	if gunman_action == "shot" then
		gunman_a_shot()
	end
	if gunman_action == "fire" then
		gunman_a_fire()
	end
	if pad:cross() then
		didshothit()
	end
	if can_shoot >= 1 then
		can_shoot = can_shoot - 1
	end
	draw_target()
	screen:print(100, 260, string.format("%07d", score), white)
	screen:print(400, 10, string.format("%03d", gunman_draw_timer), white)
	screen:print(160, 10, string.format("%03d", your_time), white)
	screen:print(210, 260, string.format("%02d", kill_count), white)
	screen:print(275, 260, string.format("%02d", dead_count), white)
	screen:print(430, 260, string.format("%05d", reward), white) 
end

function reset_gunman_a()
	reward = reward_base + (kill_count * 100)
	gunman_action = "walk"
	gunman_a_x = 500
	gunman_a_y = 80
	gunman_a_num = 1
	gunman_shot_timer = 10
	gunman_walk_timer = 20
	gunman_draw_timer = gunman_draw_timer_max - (kill_count * 2)
	shotdelay = 0
	can_shoot = 20
	hat_y = 80
	canshoot_on = 0
	reset_all = 0
	your_time = 0
end

function gunman_a_shot()
  if gunman_a_num < 11 then
	if gunman_shot_timer >= 1 then
		gunman_shot_timer = gunman_shot_timer - 1
	elseif gunman_shot_timer == 0 then
		gunman_a_num = gunman_a_num + 1
		gunman_shot_timer = 20
	end
  end
	if gunman_a_num == 11 and gunman_a_y < 100 then
		gunman_a_y = gunman_a_y + 1
	end
	draw_gunman_a(gunman_a_num, gunman_a_x, gunman_a_y)
	if hat_y < 190 then
		hat_y = hat_y + 2
	end
	if hat_y > 189 then
		text_timer = text_timer + 1
			if text_timer == 60 then
				text_timer = 0
				reset_all = 1
			end
	end
	draw_youwon(150, 30)
	draw_hat(218, hat_y)
end

function gunman_a_walk()
	if gunman_walk_timer >= 1 then
		gunman_walk_timer = gunman_walk_timer - 1
		gunman_a_x = gunman_a_x - walkspeed_gunman_a
	elseif gunman_walk_timer == 0 then
		gunman_a_num = gunman_a_num + 1
		if gunman_a_num == 4 then
			gunman_a_num = 1
		end
		gunman_walk_timer = 20
	end

	if gunman_a_x <= 200 then
		gunman_walk_timer = -1
		gunman_action = "draw"
		gunman_a_num = gunman_a_num + 1
		canshoot_on = 1
	end

	draw_gunman_a(gunman_a_num, gunman_a_x, gunman_a_y)

end

function gunman_a_draw()
	if gunman_draw_timer >= 1 then
		gunman_draw_timer = gunman_draw_timer - 1
		your_time = your_time + 1
		if your_time == 5 or your_time == 10 then
			gunman_a_num = gunman_a_num + 1
		end
		draw_fire(220, 20)
	else
		if gunman_shoot_timer >= 1 then
			draw_youlost(150, 30)
			gunman_shoot_timer = gunman_shoot_timer - 1
		end

		if gunman_shoot_timer == 0 then
			gunman_action = "fire"
--			gunman_a_num = gunman_a_num + 1
			dead_count = dead_count - 1
		end
	end
	draw_gunman_a(gunman_a_num, gunman_a_x, 80)
end

function gunman_a_fire()
	draw_youlost(150, 30)
	if dead_count >= 1 then
		text_timer = text_timer + 1
			if text_timer == 60 then
				gunman_action = "leave"
				text_timer = 0
				gunman_a_num = gunman_a_num + 1
			end
	end
	if dead_count == 0 then
		level_gameover()
	end
	draw_gunman_a(gunman_a_num, gunman_a_x, 80)
end

function gunman_a_leave()	
	if gunman_walk_timer >= -20 then
		gunman_walk_timer = gunman_walk_timer - 1
		gunman_a_x = gunman_a_x + leavespeed_gunman_a
	end
	if gunman_walk_timer == -21 then
		gunman_a_num = gunman_a_num + 1
		if gunman_a_num == 10 then
			gunman_a_num = 7
		end
		gunman_walk_timer = -1
	end
	if gunman_a_x > 500 then
		reset_all = 1
	end
	if foul == 1 then
		draw_foul(250, 30)
	end
	draw_gunman_a(gunman_a_num, gunman_a_x, 80)
end

function level_intro()
	while true do
		screen:clear()
		screen:blit(0,0,wild_gunman_modea_bg)
		levelopen = levelopen - 1
		draw_img_round()
		draw_number(level)
		screen.flip()
		screen.waitVblankStart()
		if levelopen == 0 then
			dogshot = 0
			dog_no_duck_y = 150
			break
		end
	end
	level = level + 1
	if level == 11 then
		level = 1
	end
	can_shoot = 20
	dognum = 0
	levelopen = 100
end

level_intro()

function level_gameover()
	read_hs()
	savescore()
	while true do
		pad = Controls.read()
		if pad:triangle() then
			break
		end
		if pad:l() then
			if pad:select() then
				end_game = 1
			end
		end
		screen:clear()
		screen:blit(0,0,wild_gunman_modea_bg)
		draw_youlost(150, 30)
		draw_gunman_a(gunman_a_num, gunman_a_x, 80)
		draw_img_gameover()
		screen:print(160, 80, "Press triangle to play again", white)
		draw_target()
		screen:print(100, 260, string.format("%07d", score), white)
		screen:print(400, 10, string.format("%03d", gunman_draw_timer), white)
		screen:print(160, 10, string.format("%03d", your_time), white)
		screen:print(210, 260, string.format("%02d", kill_count), white)
		screen:print(275, 260, string.format("%02d", dead_count), white)
		screen:print(430, 260, string.format("%05d", reward), white) 
		screen.flip()
		screen.waitVblankStart()
	end
	can_shoot = 20
	level = 1
	levelopen = 100
	score = 0
	shotdelay = 0
	canshoot_on = 0
	reset_all = 0
	your_time = 0
	text_timer = 0
	kill_count = 0
	dead_count = 3
	level_intro()
	reset_gunman_a()
end


-- MAIN LOOP --
while true do
	screen:clear()
	screen:blit(0,0,wild_gunman_modea_bg)
	wild_modea()
	if pad:l() then
		if pad:select() then
			break
		end
	end
	if pad:start() then
		ingamepause()
	end
	if end_game == 1 then
		break
	end
	screen.flip()
	screen.waitVblankStart()
	if reset_all == 1 then
		reset_gunman_a()
	end
end